-- DragDrop field to table

--  Created by Alain Le Gallou on 03/11/06.
--  Copyright 2006 L.A.I. All rights reserved.

-- Interface builder assignement --
-- Field name "In"
-- Table name "OutTable"
-- no column name - no drag/drop information
-- Scroll view - no drag/drop information
-- Table view - Drop
-- Field - Drag

on awake from nib theObject
	
	if the name of theObject is "In" then
		-- Prepare the input field to drag with predefine data
		tell theObject to register drag types {"string"}
		set the contents of text field "In" of window 1 to "Drag me" as string
	end if
	
	if the name of theObject is "OutTable" then
		tell theObject to register drag types {"string"} -- for all object
		-- Define the data associate with the table via a data source
		set theDataSourceOutTable to make new data source at end of data sources with properties {name:"Out"}
		make new data column at end of data columns of theDataSourceOutTable with properties {name:"colOut1", sort order:ascending, sort type:alphabetical, sort case sensitivity:case sensitive}
		
		-- Assign the data source to theObject table view
		-- and give a name for its reference
		set data source of theObject to theDataSourceOutTable
		
		append theDataSourceOutTable with {"aaa", "bbb", "ccc"} -- Store data
	end if
end awake from nib

on drag theObject drag info dragInfo --------------------------------
	if the name of theObject is "In" then
		tell theObject to register drag types {"string"}
		set the pastboard to the contents of theObject -- "Drag me"
	end if
end drag

on drop theObject drag info dragInfo --------------------------------	
	if the name of theObject is "OutTable" then -- Table case --		
		if "string" is in types of pasteboard of dragInfo then
			tell theObject to register drag types {"string"} -- must be same
			
			-- Assign the table data source to access data
			set laDataSource to data source of theObject -- {data source id 6}			
			set update views of laDataSource to false -- if long process
			
			set contentOfPasboard to contents of pasteboard of dragInfo -- "Drag me"	
			
			set laDataRow to make new data row at end of data rows of laDataSource
			set contents of data cell "colOut1" of laDataRow to contentOfPasboard
			-- Care "colOut1" is the column name of the data source not the table view
			
			set update views of laDataSource to true
		end if
	end if
	return true -- to confirm, if not the drop is cancel
end drop

on conclude drop theObject drag info dragInfo
	(*Add your script here.*)
end conclude drop


